/**
  Example program to demonstrate when signal handlers are needed.
  Orion Sky Lawlor, olawlor@acm.org, 2006/02/03 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

unsigned char buf[10]={
	0xf0,0x0f /* illegal opcode: lock prefix */
};

typedef void (*void_fn)(void);
volatile void_fn f=(void_fn)(void *)(buf);

void signal_handler(int sig) { /* <- Called when a SIGILL occurs */
	static int hit_already=0;
	if (hit_already++!=0) {printf("Re-entered signal handler!\n");exit(1);}
	else printf("Inside signal handler--fixing code\n");
	/* Fix up illegal instruction's code */
	buf[0]=0xc3; /* overwrite bad first instruction with "ret" machine code */
}

int main() {
	signal(SIGILL,signal_handler); /* <- Listen for signal */
	
	printf("Calling function\n");
	f();
	printf("Back from function\n");
	return 0;
}
